<?php
/*  Copyright 2009  Dmitry Ulman  (email : dima.ulman@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
	Plugin Name: TwitPlusNNNF
        Plugin URI: http://dnhints.com/plus/
	Description: This plugin allows you to automatically twit your new/edited posts. Combined with url shortener <a href="http://nn.nf">nn.nf</a>.
	Version: 1.0
	Author: Dmitry Ulman
*/

define ('TWITPLUSNNNF_TWITTER_URL', 'http://www.twitter.com/');
define ('TWITPLUSNNNF_STORED_PASS', '**********');

add_action('admin_menu', 'tpnnnf_add_custom_box');
add_action('publish_post', 'tpnnnf_save_postdata', 1, 2);
add_action('wp_ajax_tpnnnf_testacc', 'tpnnnf_test_acc');

function tpnnnf_add_custom_box(){
    if( function_exists( 'add_meta_box' )) {
        add_meta_box('twitplusnnnf_post', __('TwitPlusNNNF', 'tpnnnf_textdomain' ) , 'twitplusnnnf_post_content', 'post', 'side', 'high');
    } else {
        add_action('dbx_post_advanced', 'twitplusnnnf_post_content_old' );
    }
}
function twitplusnnnf_post_content(){
    global $post;
    $storedPass = TWITPLUSNNNF_STORED_PASS;
    $stored_text = get_option('tpnnnf-stored-text');
    if (empty($stored_text))
        $stored_text = 'My new blog post "{title}" {nnnf}';
    $stored_user = get_option('tpnnnf-stored-user');
    $stored_pass = empty($stored_user) ? '' : $storedPass;
    
    $cb = get_option('tpnnnf-checked') == 1 ? 'checked' : '';
    if ($post->post_status == 'publish')
        $cb = '';
    echo '<input type="hidden" name="tpnnnf_noncename" id="tpnnnf_noncename" value="'.wp_create_nonce( plugin_basename(__FILE__) ) . '" />';
    echo '<label for="tpnnnf_text">' . __("Twitter post text:", 'tpnnnf_textdomain' ) . '</label> ';
    echo '<textarea name="tpnnnf_text" id="tpnnnf_text" style="width:95%;height:5em;" wrap="hard">'.$stored_text.'</textarea>';
    
    echo '<input type="checkbox" name="tpnnnf_post" id="tpnnnf_post" value="1" '.$cb.' />';
    echo '<label for="tpnnnf_post">' . __("When I publish post to twitter", 'tpnnnf_textdomain' ) . '</label><br />';
    echo '<a href="javascript:;" class="hide-if-no-js" onclick="jQuery(\'.tpnnnf_options\').slideDown(\'normal\');jQuery(\'#tpnnnf-edit\').hide();" id="tpnnnf-edit">Edit twitter settings</a>';
    echo ' | <a href="javascript:;" class="hide-if-no-js" onclick="jQuery(\'.tpnnnf_help\').slideDown(\'normal\');jQuery(\'#tpnnnf-help\').hide();" id="tpnnnf-help">Show help</a>';
    echo '<div id="tpnnnf_options" class="tpnnnf_options hide-if-js" style="padding:3px;">';
    echo '<input type="text" name="tpnnnf_user" id="tpnnnf_user" value="'.$stored_user.'"/> Username';
    echo '<input type="text" name="tpnnnf_pass" id="tpnnnf_pass" value="'.$stored_pass.'"/> Password';
    echo '<br />';
    echo '<p>&nbsp; &nbsp; <a class="button" href="javascript:;" onclick="jQuery(\'#tpnnnf-status\').html(\'Testing...\'); jQuery.post(\'admin-ajax.php\', {\'action\':\'tpnnnf_testacc\', \'cookie\':encodeURIComponent(document.cookie), \'username\':jQuery(\'#tpnnnf_user\').val(), \'password\':jQuery(\'#tpnnnf_pass\').val()}, ';
    echo 'function (res){if (res == 0) {jQuery(\'#tpnnnf-status\').html(\'Invalid\')} else {jQuery(\'#tpnnnf-status\').html(\'Confirmed\')} }';
    echo ')">Test</a> ';
    echo '<a href="javascript:;" onclick="jQuery(\'.tpnnnf_options\').slideUp(\'normal\');jQuery(\'#tpnnnf-edit\').show();" class="button">Hide</a>';
    echo ' &nbsp; <span id="tpnnnf-status"></span></p>';
    echo '</div>';
    echo '<div id="tpnnnf_help" class="tpnnnf_help hide-if-js" style="padding:3px;">';
    echo '<br \>';
    echo '{nnnf} - short url to your post<br \>';
    echo '{url} - original url to your post<br \>';
    echo '{title} - post title<br \>';
    echo '{blog-name} - blog name<br \>';
    echo '{blog-url} - blog url<br \>';
    echo '';
    echo '<br /><a href="javascript:;" onclick="jQuery(\'.tpnnnf_help\').slideUp(\'normal\');jQuery(\'#tpnnnf-help\').show();">Hide help</a>';
    echo '</div>';
}
function twitplusnnnf_post_content_old(){
    echo 'Sorry. Your WP verison is not supported. WP 2.5+ required.';
}
function tpnnnf_test_acc(){
    $storedPass = TWITPLUSNNNF_STORED_PASS;
    $twURL  = TWITPLUSNNNF_TWITTER_URL;
    
    $user = $_POST['username'];
    $pass = $_POST['password'];
    if ($pass == $storedPass)
        $pass = get_option('tpnnnf-stored-pass');
    $res = tpnnnf_load_url($twURL.'/account/verify_credentials.json', '', $user, $pass);

    if (is_numeric(strpos($res, 'error'))){
        echo 0;
    } else {
        echo 1;
    }
}

function tpnnnf_load_url($url, $ps, $user='', $pass=''){

    $headers = array('Expect:');

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_USERAGENT, 'TwitPlusNNNF');
    curl_setopt($ch, CURLOPT_URL, $url);

    if (!empty($ps)){
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $ps);
    }
    if (!empty($user))
        curl_setopt($ch, CURLOPT_USERPWD, $user.':'.$pass);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT, 20);
    curl_setopt($ch, CURLOPT_MAXREDIRS, 20);
    curl_setopt($ch, CURLOPT_VERBOSE, 0);

    $res = curl_exec($ch);
    curl_close($ch);
    return $res;
}
function tpnnnf_save_postdata($postID, $pData){
    global $post;
    $twURL  = TWITPLUSNNNF_TWITTER_URL;
    $storedPass = TWITPLUSNNNF_STORED_PASS;
    if ( !wp_verify_nonce( $_POST['tpnnnf_noncename'], plugin_basename(__FILE__) )) 
        return $postID;

    if ( 'post' == $_POST['post_type'] ) {
        if ( !current_user_can( 'edit_post', $postID ))
            return $postID;
  
        if (isset($_POST['tpnnnf_post'])){
            $twt_text = stripslashes($_POST['tpnnnf_text']);
            update_option('tpnnnf-stored-text', $twt_text);
            update_option('tpnnnf-checked', 1);

            $user = $_POST['tpnnnf_user'];
            $pass = $_POST['tpnnnf_pass'];
            update_option('tpnnnf-stored-user', $user);
            if ($pass != $storedPass)
                update_option('tpnnnf-stored-pass', $pass);
            else
                $pass = get_option('tpnnnf-stored-pass');

            // post_title, post_content
            $permalink = get_permalink($postID);
            $twt_text = str_replace('{url}', $permalink, $twt_text);
            $twt_text = str_replace('{title}', $pData->post_title, $twt_text);
            $twt_text = str_replace('{blog-name}', get_bloginfo('name'), $twt_text);
            $twt_text = str_replace('{blog-url}', get_bloginfo('siteurl'), $twt_text);
            if (is_numeric(strpos($twt_text, '{nnnf}'))){
                $nnnf = tpnnnf_load_url('http://nn.nf/api.php', array('url'=>$permalink));

                if (substr($nnnf, 0, 13) == 'http://nn.nf/')
                    $twt_text = str_replace('{nnnf}', $nnnf, $twt_text);
            }

            $res = tpnnnf_load_url($twURL.'/statuses/update.xml', array('status'=>substr($twt_text, 0, 140)), $user, $pass);
            
        } else {
            update_option('tpnnnf-checked', 0);
        }
    }
}
?>
